<template>
  <div>
    <template v-if="shouldShow">
      <router-link v-if="!node.children" :to="{name: node.name}">
        <el-menu-item :index="index" class='submenu-title-noDropdown'>
          <font-awesome-icon
            v-if="hasIcon"
            :icon="icon"
          />
          <span slot="title">
            {{ title }}
          </span>
        </el-menu-item>
      </router-link>
      <el-submenu
        v-else
        :index="index"
      >
        <template slot="title">
          <font-awesome-icon
            v-if="hasIcon"
            :icon="icon"
          />
          <span slot="title">{{ title }}</span>
        </template>
        <component
          v-for="child in node.children" :key="child.name"
          is="MenuTree"
          :node="child" />
      </el-submenu>
    </template>
  </div>
</template>

<script>
  export default {
    name: 'MenuTree',
    props: {
      node: {
        type: Object,
        required: true
      }
    },
    computed: {
      shouldShow() {
        if ( this.title ) {
          return this.$can(...this.node.meta.can)
        } else {
          return false
        }
      },
      hasIcon() {
        return Boolean(this.node.meta && this.node.meta.icon)
      },
      icon() {
        return this.node.meta && this.node.meta.icon
      },
      index() {
        if ( this.node.name ) {
          return this.node.name
        } else {
          console.warn('Missing name for the route:', this.node)
        }
      },
      title() {
        return this.node.meta && this.node.meta.title
      }
    }
  }

</script>
